searchNodes=[{"type":"module","title":"TypedStructEctoChangeset","doc":"A TypedStruct plugin to integrate ecto changeset, that lets you use a typedstruct module as an Ecto schema module when casting changesets. Embeds and assoc are not yet supported, but you can use Ecto.Type implementation instead The plugin works by generating a __changeset__/0 function in the invoking module, which is called by Ecto.Changeset.cast/3 to cast types. Examples If this module is defined: defmodule TypedStructModule do use TypedStruct typedstruct do plugin TypedStructEctoChangeset field :age , integer ( ) field :name , String . t ( ) end end Then we can: iex&gt; Ecto.Changeset . cast ( % TypedStructModule { } , %{ &quot;age&quot; =&gt; 23 , &quot;name&quot; =&gt; &quot;John Doe&quot; } , [ :age , :name ] ) % Ecto.Changeset { } Notes Supports as many Ecto types as possible including :decimal , :date , :time , :datetime , from their corresponding typespecs Decimal.t() , etc. Also converts any() , term() or map() types in field specifications to :map , and list types, like [integer()] to e.g. {:array, :integer} . You can supply a :usec_times option to the plugin. If the option is true , then Time.t() , DateTime.t() and NaiveDateTime.t() fields will produce the Ecto types :time_usec , :datetime_usec and naive_datetime_usec . For example: defmodule TypedStructModule do use TypedStruct typedstruct do plugin TypedStructEctoChangeset , usec_times : true field :time_with_usec , Time . t ( ) field :updated_at_with_usec , NaiveDateTime . t ( ) end end","ref":"TypedStructEctoChangeset.html"},{"type":"function","title":"TypedStructEctoChangeset.field/4","doc":"Callback implementation for TypedStruct.Plugin.field/4 .","ref":"TypedStructEctoChangeset.html#field/4"},{"type":"extras","title":"TypedStructEctoChangeset","doc":"A plugin to enable basic &quot;embeds&quot; Ecto.cast support to the module created by the containing TypedStruct macro.","ref":"readme.html"},{"type":"extras","title":"TypedStructEctoChangeset - Example","doc":"If this module is defined: defmodule TypedStructModule do use TypedStruct typedstruct do plugin TypedStructEctoChangeset field :age , integer ( ) field :name , String . t ( ) end end Then we can: iex&gt; Ecto.Changeset . cast ( % TypedStructModule { } , %{ &quot;age&quot; =&gt; 23 , &quot;name&quot; =&gt; &quot;John Doe&quot; } , [ :age , :name ] ) % Ecto.Changeset { }","ref":"readme.html#example"},{"type":"extras","title":"TypedStructEctoChangeset - Limitations","doc":"More database-centric fields such as assoc are not yet supported","ref":"readme.html#limitations"},{"type":"extras","title":"TypedStructEctoChangeset - Installation","doc":"Because this plugin supports the interface defined by the TypedStruct macro, installation assumes you've already added that dependency. While you can use the original typed_struct library, it seems to no longer be maintained. However, there is a fork here that is quite active. If available in Hex , the package can be installed by adding typed_struct_ecto_changeset to your list of dependencies in mix.exs : def deps do [ # Choose either of the following `TypedStruct` libraries # The original TypedStruct library { :typed_struct , &quot;~&gt; 0.3.0&quot; } , # Or the newer forked TypedStruct library { :typedstruct , &quot;~&gt; 0.5.2&quot; } , # And add this library { :typed_struct_ecto_changeset , &quot;~&gt; 1.0.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/typed_struct_ecto_changeset .","ref":"readme.html#installation"}]